/*	
 *	clipbary.c
 *
 *	ėprbgz
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001-2014 Naoyuki Sawa
 *
 *	* Tue Dec 20 00:06:44 JST 2011 Naoyuki Sawa
 *	- 1st [XB
 *	* Thu Nov 20 20:22:14 JST 2014 Naoyuki Sawa
 *	- LSBso[WɉāAMSBso[W쐬܂B
 *	- bitarray_get(),bitarray_set()Abitarray_lsb1st_get(),bitarray_lsb1st_set()ɖ̕ύX܂B
 *	- VKɁAbitarray_msb1st_get(),bitarray_msb1st_set()ǉ܂B
 *	  bitarray_msb1st_get(),bitarray_msb1st_set()͂܂AAZuĂ܂B
 *	* Sat Nov 22 11:57:45 JST 2014 Naoyuki Sawa
 *	- bitarray_msb1st_get()AZu܂B
 *	  ̏Ձ`Ղ́Abitarray_lsb1st_get()̃AZułƂقړŁAVtgႤłB
 *	  ̏IՂ́Abitarray_lsb1st_get()ƈقȂA}XNKv̂ŁAPɂȂ܂B
 *	- HuffmanDecoder_Decode()gpāACłƓʂɂȂ邱Ƃ𓮍mF܂B
 *	  HuffmanDecoder_Decode()ŁA39KB˖62KB̓WJs̑xA1.203b˖1.106bɍ܂B(Clock=48MHz,Stack=FRAM)
 *	  bitarray_msb1st_get()P̂ŁAǂꂮ炢́A܂vĂ܂B
 *	* Sat Nov 22 13:00:53 JST 2014 Naoyuki Sawa
 *	- bitarray_msb1st_set()AZu܂B
 *	  ̏ՂƏIՂ́Abitarray_lsb1st_set()̃AZułƂقړŁAVtgႤłB
 *	  ̒Ղ́Abitarray_lsb1st_set()ƈقȂA}XNƒlꂼɃVtg悤ɂȂ܂B
 *	- HuffmanEncoder_Encode()gpāACłƓʂɂȂ邱Ƃ𓮍mF܂B
 *	  HuffmanEncoder_Encode()ŁA62KB˖39KB̈ks̑xA12.91b˖12.69bɍ܂B(Clock=48MHz,Stack=FRAM)
 *	  bitarray_msb1st_set()P̂ŁAǂꂮ炢́A܂vĂ܂B
 *	* Sat Nov 29 10:50:31 JST 2014 Naoyuki Sawa
 *	- bitarray_lsb1st_get(),bitarray_msb1st_get()Aclipbary.cframbary.c֕܂B
 *	  HuffmanDecoder_Decode()ŁA39KB˖62KB̓WJs̑xAȉ̂悤ɍ܂B(Clock=48MHz,Code=FRAM,Stack=FRAM)
 *	  RAMɔzu郂W[:                ˖0.756b
 *	  RAMɔzu郂W[:frambary.o          ˖0.586b
 *	  RAMɔzu郂W[:framhfm.o           ˖0.418b
 *	  RAMɔzu郂W[:frambary.o+framhfm.o˖0.248b
 */
#include "clip.h"

/*****************************************************************************
 *	
 *****************************************************************************/

#ifndef PIECE
void bitarray_lsb1st_set(void* ptr, int pos, int bits, int value) {
	//
	//	                                              s2               s1
	//	                                              /                /
	//	                                        +----------+----------------------+
	//	MSB|........ .......x xxxxxxxx xxxxxxxx|xxxxxxxx xxx..... ........ ........|LSB
	//	                    +------------------------------+                      |
	//	                                   /               |                      |
	//	                                 bits             pos                     p
	//	             mask = 1_11111111_11111111_11111111_111
	//
	int s1;
	int s2;
	int mask;
	int* p;
	/* 1bitAyсA32bit߂̑͑ΉĂ܂B */
	if((bits < 1) || (bits > 32)) { DIE(); }
	/* 32bitPʂ̃|C^߂܂B */
	p = (int*)ptr + (pos >> 5);
	/* p[0]̈ʒuintlɊ܂܂Asvbit߂܂B */
	s1 = pos & 31;	/* 0`31 */
	/* p[0]̈ʒuintlɊ܂܂AKvbit߂܂B */
	s2 = 32 - s1;	/* 1`32 */
	/* i[ĺAsvbit}XN܂B */
	mask  = (unsigned)-1    >> (32 - bits);
	value &= mask;
	/* p[0]̈ʒuintlɁAKvbit܂B */
	p[0] &= ~((unsigned)mask  << s1);
	p[0] |=   (unsigned)value << s1;
	/* p[1]̈ʒuintlɁAKvbit܂Ăc */
	if(bits > s2) {
		/* p[1]̈ʒuintlɁAKvbit܂B */
		p[1] &= ~((unsigned)mask  >> s2);
		p[1] |=   (unsigned)value >> s2;
	}
}
#else /*PIECE*/
void bitarray_lsb1st_set(void* ptr, int pos, int bits, int value);
asm("
		.code
		.align		1
		.global		bitarray_lsb1st_set
bitarray_lsb1st_set:
		;//-------------------------------------;//
		;// %r12 := ptr
		;// %r13 := pos
		;// %r14 := bits
		;// %r15 := value
		xand		%r4, %r13, 31		;// %r4  := s1 = pos & 31
;//{{xldextgߖ
;//		xld.w		%r5, 32			;// %r5  := s2 = 32 - s1
;//		sub		%r5, %r4
;//xldextgߖ
		not		%r5, %r4		;// %r5  := s2 = 32 - s1 = 33 + ~s1
		add		%r5, 33
;//}}xldextgߖ
		srl		%r13, 5			;// %r12 := p = (const int*)ptr + (pos >> 5)
		sll		%r13, 2
		add		%r12, %r13
		;//-------------------------------------;//
		;// %r4  := s1
		;// %r5  := s2
		;// %r12 := p
		;// %r14 := bits
		;// %r15 := value
		ld.w		%r6, -1			;// %r6  := -1
;//{{xldextgߖ
;//		xld.w		%r7, 32			;// %r7  := 32 - bits
;//		sub		%r7, %r14
;//xldextgߖ
		not		%r7, %r14		;// %r7  := 32 - bits = 33 + ~bits
		add		%r7, 33
;//}}xldextgߖ
;//{{%r7j󂵂Ăǂ̂xsrlœK
;//		xsrl		%r6, %r7		;// %r6  := mask = (unsigned)-1 >> (32 - bits)
;//%r7j󂵂Ăǂ̂xsrlœK
		cmp		%r7, 8			;//<---+
		jrle		4			;//--+ |
		srl		%r6, 8			;//  | |
		jp.d		-3			;//--|-+
		sub		%r7, 8			;//  |							*delay*
		srl		%r6, %r7		;//<-+
;//}}%r7j󂵂Ăǂ̂xsrlœK
		and		%r15, %r6		;// %r15 := value &= mask
		;//-------------------------------------;//
		;// %r4  := s1
		;// %r5  := s2
		;// %r6  := mask
		;// %r12 := p
		;// %r14 := bits
		;// %r15 := value
		ld.w		%r7, [%r12]		;// %r7  := tmp = p[0]
		ld.w		%r10, %r6		;// %r10 :=                   mask
		ld.w		%r11, %r15		;// %r11 :=                   value
;//{{%r4j󂵂Ăǂ̂xsllœK
;//		xsll		%r10, %r4		;// %r10 :=         (unsigned)mask  << s1
;//		xsll		%r11, %r4		;// %r11 :=         (unsigned)value << s1
;//%r4j󂵂Ăǂ̂xsllœK
		cmp		%r4, 8			;//<---+
		jrle		5			;//--+ |
		sll		%r10, 8			;//  | |
		sll		%r11, 8			;//  | |
		jp.d		-4			;//--|-+
		sub		%r4, 8			;//  |							*delay*
		sll		%r10, %r4		;//<-+
		sll		%r11, %r4
;//}}%r4j󂵂Ăǂ̂xsllœK
		not		%r10, %r10		;// %r10 :=       ~((unsigned)mask  << s1)
		and		%r7, %r10		;// %r7  := tmp & ~((unsigned)mask  << s1)
		or		%r7, %r11		;// %r7  := tmp & ~((unsigned)mask  << s1) | ((unsigned)value << s1)
		ld.w		[%r12]+, %r7		;// p[0]  = tmp
		;//-------------------------------------;//
		;// %r5  := s2
		;// %r6  := mask
		;// %r12 := p
		;// %r14 := bits
		;// %r15 := value
		cmp		%r14, %r5		;// if(bits > s2)
		jrle		14			;//---------------------------------------------------------------------+
		 ld.w		%r7, [%r12]		;//   %r7  := tmp = p[1]						|
;//{{%r5j󂵂Ăǂ̂xsrlœK		;//									|
;//		 xsrl		%r6, %r5		;//   %r6  :=         (unsigned)mask  >> s2				|
;//		 xsrl		%r15, %r5		;//   %r15 :=         (unsigned)value >> s2				|
;//%r5j󂵂Ăǂ̂xsrlœK		;//									|
		 cmp		%r5, 8			;//<---+								|
		 jrle		5			;//--+ |								|
		 srl		%r6, 8			;//  | |								|
		 srl		%r15, 8			;//  | |								|
		 jp.d		-4			;//--|-+								|
		 sub		%r5, 8			;//  |							*delay*		|
		 srl		%r6, %r5		;//<-+									|
		 srl		%r15, %r5		;//									|
;//}}%r5j󂵂Ăǂ̂xsrlœK		;//									|
		 not		%r6, %r6		;//   %r6  :=       ~((unsigned)mask  >> s2)				|
		 and		%r7, %r6		;//   %r7  := tmp & ~((unsigned)mask  >> s2)				|
		 or		%r7, %r15		;//   %r7  := tmp & ~((unsigned)mask  >> s2) | ((unsigned)value >> s2)	|
		 ld.w		[%r12], %r7		;//   p[1]  = tmp							|
		ret					;//<--------------------------------------------------------------------+
");
#endif/*PIECE*/

/*****************************************************************************
 *	
 *****************************************************************************/

#ifndef PIECE
void bitarray_msb1st_set(void* ptr, int pos, int bits, int value) {
	//
	//	                s1               s2
	//	                /                /
	//	    +----------------------+----------+
	//	MSB|........ ........ .....xxx xxxxxxxx|xxxxxxxx xxxxxxxx x....... ........|LSB
	//	    |                      +------------------------------+               |
	//	    |                      |              /                               |
	//	    p                     pos           bits                              p
	//	                    mask = 111_11111111_11111111_11111111_1
	//
	int s1;
	int s2;
	int mask;
	int* p;
	/* 1bitAyсA32bit߂̑͑ΉĂ܂B */
	if((bits < 1) || (bits > 32)) { DIE(); }
	/* 32bitPʂ̃|C^߂܂B */
	p = (int*)ptr + (pos >> 5);
	/* p[0]̈ʒuintlɊ܂܂Asvbit߂܂B */
	s1 = pos & 31;	/* 0`31 */
	/* p[0]̈ʒuintlɊ܂܂AKvbit߂܂B */
	s2 = 32 - s1;	/* 1`32 */
	/* i[ĺAsvbit}XN܂B */
	mask  = (unsigned)-1    << (32 - bits);
	value = (unsigned)value << (32 - bits);
	/* p[0]̈ʒuintlɁAKvbit܂B */
	p[0] &= ~((unsigned)mask  >> s1);
	p[0] |=   (unsigned)value >> s1;
	/* p[1]̈ʒuintlɁAKvbit܂Ăc */
	if(bits > s2) {
		/* p[1]̈ʒuintlɁAKvbit܂B */
		p[1] &= ~((unsigned)mask  << s2);
		p[1] |=   (unsigned)value << s2;
	}
}
#else /*PIECE*/
void bitarray_msb1st_set(void* ptr, int pos, int bits, int value);
asm("
		.code
		.align		1
		.global		bitarray_msb1st_set
bitarray_msb1st_set:
		;//-------------------------------------;//
		;// %r12 := ptr
		;// %r13 := pos
		;// %r14 := bits
		;// %r15 := value
		xand		%r4, %r13, 31		;// %r4  := s1 = pos & 31
;//{{xldextgߖ
;//		xld.w		%r5, 32			;// %r5  := s2 = 32 - s1
;//		sub		%r5, %r4
;//xldextgߖ
		not		%r5, %r4		;// %r5  := s2 = 32 - s1 = 33 + ~s1
		add		%r5, 33
;//}}xldextgߖ
		srl		%r13, 5			;// %r12 := p = (const int*)ptr + (pos >> 5)
		sll		%r13, 2
		add		%r12, %r13
		;//-------------------------------------;//
		;// %r4  := s1
		;// %r5  := s2
		;// %r12 := p
		;// %r14 := bits
		;// %r15 := value
		ld.w		%r6, -1			;// %r6  := -1
;//{{xldextgߖ
;//		xld.w		%r7, 32			;// %r7  := 32 - bits
;//		sub		%r7, %r14
;//xldextgߖ
		not		%r7, %r14		;// %r7  := 32 - bits = 33 + ~bits
		add		%r7, 33
;//}}xldextgߖ
;//{{%r7j󂵂Ăǂ̂xsllœK
;//		xsll		%r6, %r7		;// %r6  := mask  = (unsigned)-1    << (32 - bits)
;//		xsll		%r15, %r7		;// %r15 := value = (unsigned)value << (32 - bits)
;//%r7j󂵂Ăǂ̂xsllœK
		cmp		%r7, 8			;//<---+
		jrle		5			;//--+ |
		sll		%r6, 8			;//  | |
		sll		%r15, 8			;//  | |
		jp.d		-4			;//--|-+
		sub		%r7, 8			;//  |							*delay*
		sll		%r6, %r7		;//<-+
		sll		%r15, %r7		;//
;//}}%r7j󂵂Ăǂ̂xsllœK
		;//-------------------------------------;//
		;// %r4  := s1
		;// %r5  := s2
		;// %r6  := mask
		;// %r12 := p
		;// %r14 := bits
		;// %r15 := value
		ld.w		%r7, [%r12]		;// %r7  := tmp = p[0]
		ld.w		%r10, %r6		;// %r10 :=                   mask
		ld.w		%r11, %r15		;// %r11 :=                   value
;//{{%r4j󂵂Ăǂ̂xsrlœK
;//		xsrl		%r10, %r4		;// %r10 :=         (unsigned)mask  >> s1
;//		xsrl		%r11, %r4		;// %r11 :=         (unsigned)value >> s1
;//%r4j󂵂Ăǂ̂xsrlœK
		cmp		%r4, 8			;//<---+
		jrle		5			;//--+ |
		srl		%r10, 8			;//  | |
		srl		%r11, 8			;//  | |
		jp.d		-4			;//--|-+
		sub		%r4, 8			;//  |							*delay*
		srl		%r10, %r4		;//<-+
		srl		%r11, %r4
;//}}%r4j󂵂Ăǂ̂xsrlœK
		not		%r10, %r10		;// %r10 :=       ~((unsigned)mask  >> s1)
		and		%r7, %r10		;// %r7  := tmp & ~((unsigned)mask  >> s1)
		or		%r7, %r11		;// %r7  := tmp & ~((unsigned)mask  >> s1) | ((unsigned)value >> s1)
		ld.w		[%r12]+, %r7		;// p[0]  = tmp
		;//-------------------------------------;//
		;// %r5  := s2
		;// %r6  := mask
		;// %r12 := p
		;// %r14 := bits
		;// %r15 := value
		cmp		%r14, %r5		;// if(bits > s2)
		jrle		14			;//---------------------------------------------------------------------+
		 ld.w		%r7, [%r12]		;//   %r7  := tmp = p[1]						|
;//{{%r5j󂵂Ăǂ̂xsllœK		;//									|
;//		 xsll		%r6, %r5		;//   %r6  :=         (unsigned)mask  << s2				|
;//		 xsll		%r15, %r5		;//   %r15 :=         (unsigned)value << s2				|
;//%r5j󂵂Ăǂ̂xsllœK		;//									|
		 cmp		%r5, 8			;//<---+								|
		 jrle		5			;//--+ |								|
		 sll		%r6, 8			;//  | |								|
		 sll		%r15, 8			;//  | |								|
		 jp.d		-4			;//--|-+								|
		 sub		%r5, 8			;//  |							*delay*		|
		 sll		%r6, %r5		;//<-+									|
		 sll		%r15, %r5		;//									|
;//}}%r5j󂵂Ăǂ̂xsllœK		;//									|
		 not		%r6, %r6		;//   %r6  :=       ~((unsigned)mask  << s2)				|
		 and		%r7, %r6		;//   %r7  := tmp & ~((unsigned)mask  << s2)				|
		 or		%r7, %r15		;//   %r7  := tmp & ~((unsigned)mask  << s2) | ((unsigned)value << s2)	|
		 ld.w		[%r12], %r7		;//   p[1]  = tmp							|
		ret					;//<--------------------------------------------------------------------+
");
#endif/*PIECE*/
